diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 1a95924fe..cd10afc99 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -473,6 +473,11 @@ public class PacketHandlerClient extends PacketHandler
     @Override
     public void handleMapChunk(PacketBlockRegionUpdate blockRegionUpdatePacket)
     {
+        for (int x = blockRegionUpdatePacket.xPosition / 16; x <= blockRegionUpdatePacket.xPosition / 16 + blockRegionUpdatePacket.xSize / 16; x++) {
+            for (int z = blockRegionUpdatePacket.zPosition / 16; z <= blockRegionUpdatePacket.zPosition / 16 + blockRegionUpdatePacket.zSize / 16; z++) {
+                worldClientMP.doPreChunk(x, z, true);
+            }
+        }
         worldClientMP.removePositionTypesInBounds(blockRegionUpdatePacket.xPosition, blockRegionUpdatePacket.yPosition, blockRegionUpdatePacket.zPosition, (blockRegionUpdatePacket.xPosition + blockRegionUpdatePacket.xSize) - 1, (blockRegionUpdatePacket.yPosition + blockRegionUpdatePacket.ySize) - 1, (blockRegionUpdatePacket.zPosition + blockRegionUpdatePacket.zSize) - 1);
         worldClientMP.setChunkData(blockRegionUpdatePacket.xPosition, blockRegionUpdatePacket.yPosition, blockRegionUpdatePacket.zPosition, blockRegionUpdatePacket.xSize, blockRegionUpdatePacket.ySize, blockRegionUpdatePacket.zSize, blockRegionUpdatePacket.chunk);
     }
@@ -942,7 +947,7 @@ public class PacketHandlerClient extends PacketHandler
         }
         else if (containerSetslotPacket.windowId == 0 && containerSetslotPacket.itemSlot >= 36 && containerSetslotPacket.itemSlot < 45)
         {
-            ItemStack itemstack = mc.thePlayer.inventorySlots.getSlot(containerSetslotPacket.itemSlot).getItem();
+            ItemStack itemstack = mc.thePlayer.inventorySlots.getSlot(containerSetslotPacket.itemSlot).getItemStack();
             if (containerSetslotPacket.myItemStack != null && (itemstack == null || itemstack.stackSize < containerSetslotPacket.myItemStack.stackSize))
             {
                 containerSetslotPacket.myItemStack.animationsToGo = 5;
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 03df1d9c5..af733e962 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -14,6 +14,7 @@ import com.mojang.logging.LogUtils;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
+import net.minecraft.client.gui.TooltipElement;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
@@ -22,7 +23,6 @@ import net.minecraft.core.enums.Difficulty;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.option.enums.RenderScale;
-import net.minecraft.client.option.enums.TooltipStyle;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -163,7 +163,7 @@ public class GameSettings {
 	public OptionBoolean fullscreen = new OptionBoolean(this, "fullscreen", Minecraft.isClientASteamDeck());
 	public OptionBoolean borderlessFullscreen = new OptionBoolean(this, "borderlessFullscreen", true);
 	public OptionBoolean startInFullscreen = new OptionBoolean(this, "startInFullscreen", true);
-	public OptionEnum<TooltipStyle> tooltipStyle = new OptionEnum<>(this, "tooltipStyle", TooltipStyle.class);
+	public OptionTooltip tooltipStyle = new OptionTooltip(this, "tooltipStyle", "default");
 	public OptionEnum<LightmapStyle> lightmapStyle = new OptionEnum<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY);
 	public OptionBoolean customLightmap = new OptionBoolean(this, "customLightmap", true);
 	public OptionBoolean fog = new OptionBoolean(this, "fog", true);
@@ -404,6 +404,13 @@ public class GameSettings {
 				return trans.translateKey("options.bloom.high");
 			}
 		}
+		if (option == this.tooltipStyle) {
+			TooltipElement.Style style = TooltipElement.styleMap.get(this.tooltipStyle.value);
+			if (style != null) {
+				return trans.translateKey(style.translationKey);
+			}
+			return "Unknown";
+		}
 		if (option instanceof OptionBoolean) {
 			Boolean flag = (Boolean) option.value;
 			if (flag) {
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java b/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
index 40a12da61..d4dc88641 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
@@ -14,11 +14,11 @@ public abstract class OptionToggleable<E> extends Option<E> implements Toggleabl
 	}
 	
 	@Override
-	public final void toggle() {
+	public void toggle() {
 		this.value = values[(getValueIndex() + 1) % values.length];
 	}
 	
-	public final void toggle(int delta) {
+	public void toggle(int delta) {
 		this.value = values[DynamicTexture.pmod(getValueIndex() + delta, values.length)];
 	}
 	
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
new file mode 100644
index 000000000..cff0d83a4
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
@@ -0,0 +1,47 @@
+package net.minecraft.client.option;
+
+import net.minecraft.client.gui.TooltipElement;
+import net.minecraft.client.render.dynamictexture.DynamicTexture;
+import net.minecraft.core.util.helper.Toggleable;
+
+public class OptionTooltip extends OptionToggleable<String> implements Toggleable {
+
+    public OptionTooltip(final GameSettings gameSettings, final String name, final String defaultValue) {
+        super(gameSettings, name, defaultValue, null);
+    }
+
+    @Override
+    public void parse(final String string) {
+        this.value = string;
+    }
+
+    @Override
+    public void toggle() {
+        this.value = TooltipElement.stylesIdList.get((getValueIndex() + 1) % size());
+    }
+
+    @Override
+    public void toggle(final int delta) {
+        this.value = TooltipElement.stylesIdList.get(DynamicTexture.pmod(getValueIndex() + delta, size()));
+    }
+
+    @Override
+    public int getValueIndex() {
+        return TooltipElement.stylesIdList.indexOf(this.value);
+    }
+
+    @Override
+    public void setValueWithIndex(final int i) {
+        this.value = TooltipElement.stylesIdList.get(i);
+    }
+
+    @Override
+    public int size() {
+        return TooltipElement.styleMap.size();
+    }
+
+    @Override
+    public boolean isSlider() {
+        return true;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index 77050245e..5c9300f6e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -42,25 +42,26 @@ final public class LightingCache {
         }
     }
     
-    private float calcBrightness(int x, int y, int z) {
-		float brightness = block.getBlockBrightness(access, x, y, z);
+    private float calcBrightness(final int x, final int y, final int z) {
+        final int blockId = this.access.getBlockId(x, y, z);
+        final Block<?> block = Blocks.getBlock(blockId);
 
-		if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
-			int lightEmission = block.emission;
-			if(lightEmission >= 15) {
-				return 1.0f;
-			}
-			if(!mc.isAmbientOcclusionEnabled()) {
-				return 1.0f;
-			}
-            Block<?> block = access.getBlock(x, y, z);
-			if(block == null) {
-				return 1.0f;
-			}
-			return 1.0f - block.getAmbientOcclusionStrength(access, x, y, z);
-		}
-		
-		return brightness;
+        if(LightmapHelper.isLightmapEnabled() || this.mc.fullbright) {
+            if(this.block.emission >= 15) {
+                return 1.0f;
+            }
+            if(!this.mc.isAmbientOcclusionEnabled()) {
+                return 1.0f;
+            }
+            if(block == null) {
+                return 1.0f;
+            }
+            return 1.0f - block.getAmbientOcclusionStrength(this.access, x, y, z);
+        }
+        final int emission = Blocks.lightEmission[blockId];
+        final float brightness = this.access.getBrightness(x, y, z, emission);
+
+        return Math.min(brightness, (this.mc.isAmbientOcclusionEnabled() && block != null) ? (1 - block.getAmbientOcclusionStrength(this.access, x, y, z)) : 1);
     }
     
 	public float getBrightness(int relX, int relY, int relZ) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index a9ece6d4d..bd0410481 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -207,7 +207,7 @@ public class WorldRenderer
             f1 = (int)(mc.activeCamera.getFov() * 100 + 30);
             f1 *= a + (b - a) * partialTick;
         }
-        if(CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTick))
+        if(mc.gameSettings.fovModification.value && CameraUtil.isUnderLiquid(mc.activeCamera, mc.currentWorld, Material.water, partialTick))
         {
             f1 = f1 - 10;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 40e937881..5494b99a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -507,9 +507,9 @@ public class BlockModelDispatcher
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face")
             .withCustomItemBounds(0,0,0,1,1,1));
 
-        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston/side")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston/face"));
+        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston/head"), TextureRegistry.getTexture("minecraft:block/piston/shaft")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston/face"));
         addDispatch(new BlockModelEmpty<>(Blocks.PISTON_MOVING));
-        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/side"), 6/16d).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face"));
+        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/head"), TextureRegistry.getTexture("minecraft:block/piston_steel/shaft"), 6/16d, 8d/16d).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face"));
 
         addDispatch(new BlockModelStandard<>(Blocks.NOTEBLOCK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/noteblock"));
 
